import sys,struct,os,array

if sys.version_info[0] < 3:
    import lzss2 as lzss
else:
    import lzss3 as lzss

def ensure_dir(f):
    d = os.path.dirname(f)
    if not os.path.exists(d):
        os.makedirs(d)

def readu32be(file):
    return struct.unpack(">I", file.read(4))[0]

def getString(file):
    result = ""
    tmpChar = f.read(1).decode("ASCII")
    while ord(tmpChar) != 0:
        result += tmpChar
        tmpChar = f.read(1).decode("ASCII")
    return result
 
f = open(sys.argv[1], "rb")
f.seek(8)
for x in range(readu32be(f)):
    start = f.tell()
    string = getString(f)
    print(string)
    f.seek(start + 0x80)
    offset = readu32be(f)
    size = (readu32be(f) - 4)
    f.seek(0x8,1)
    DecompSize = readu32be(f)
    bringMeBack = f.tell()
    f.seek(offset + 4)
    tmp = f.read(size)
    outfile = lzss.decompress(tmp,DecompSize)
    ensure_dir(sys.argv[1].replace(".lzarc","\\") + string)
    of = open(str(sys.argv[1].replace(".lzarc","\\") + string),"wb")
    of.write(outfile)
    of.close()
    f.seek(bringMeBack)


f.close()
