import os,sys,struct
if sys.version_info[0] < 3:
    raise "This requires python 3.x"
else:
    import compress
def aline(file):
    currentPOS = file.tell()
    while(currentPOS % 0x40):
        file.write(struct.pack("B",0))
        currentPOS = file.tell()

def updateDamit(file):
    file.seek(0,1)

def write32be(file,val):
    file.write(struct.pack(">I", val))
    updateDamit(file)

def writeOffset(file,offset):
    cur = file.tell()
    file.seek(offset)
    write32be(file,cur)
    file.seek(cur)
def writeOffData(file,offset,data):
    cur = file.tell()
    file.seek(offset)
    write32be(file,data)
    file.seek(cur)
class memOffset:
    def __init__(self):
        self.Offset = 0x2000
    def addFile(self,val):
        data = val + self.Offset
        self.Offset = (data - (data % 0x2000)) + 0x4000
    

uncompData = []
uncompSize = []
dirs = []
offsetLocation = []
thatOFF = memOffset()

for subdir,dirs,files in os.walk(sys.argv[1]):
    for file in files:
        filepath = subdir + os.sep + file
        f = open(filepath,"rb")
        uncompData.append(f.read())
        f.seek(0,2)
        uncompSize.append(f.tell())
        f.close()
        dirs.append(filepath.replace(str(sys.argv[1] + "\\"),""))

file = open(sys.argv[1] + ".lzarc","wb")
file.seek(8)
write32be(file,len(dirs))
baseSize = (0xC + (0x94*len(dirs)))
baseSize = (baseSize - (baseSize % 0x40)) + 0x40
for z in range(len(dirs)):
    nextval = file.tell() + 0x80
    file.write(str(dirs[z]).replace("\\","/").encode(encoding='UTF-8',errors='strict'))
    file.seek(nextval+8)
    offsetLocation.append(nextval)
    write32be(file,thatOFF.Offset)
    thatOFF.addFile(uncompSize[z])
    write32be(file,uncompSize[z])
    write32be(file,uncompSize[z])
file.seek(baseSize)
for z in range(len(uncompData)):
    writeOffset(file,offsetLocation[z])
    curretOffsetData = file.tell()
    compress.compress_nlz11(uncompData[z],file)
    newOffset = file.tell()
    sizeofComped = newOffset - curretOffsetData
    writeOffData(file,offsetLocation[z] + 4, sizeofComped)
    file.seek(0x10 - newOffset%0x10,1)
aline(file)
writeOffset(file,0)
writeOffData(file,4,thatOFF.Offset)
    
    
    


